package com.example.androidskuska

import android.os.Bundle
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.navigation.fragment.findNavController
import com.example.androidskuska.databinding.FragmentFormBinding

/**
 * A simple [Fragment] subclass as the second destination in the navigation.
 */
class FormFragment : Fragment() {

    private var _binding: FragmentFormBinding? = null

    // This property is only valid between onCreateView and
    // onDestroyView.
    private val binding get() = _binding!!

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {

        _binding = FragmentFormBinding.inflate(inflater, container, false)
        return binding.root

    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        //ked sa stlaci tlacidlo
        binding.buttonSubmit.setOnClickListener {
            //odchytavaju errory
            val name = binding.editTextCountry.text.toString().trim().lowercase()
            if (name.isEmpty()) {
                Toast.makeText(activity, R.string.error_blank, Toast.LENGTH_LONG).show()
            } else if (App.db.getCountryDao().find(name) != null) {
                Toast.makeText(activity, R.string.error_duplicate, Toast.LENGTH_LONG).show()
            } else {
                //ulozi krajinu do databazy ked je vsetko spravne
                App.db.getCountryDao().save(Country(name))
                findNavController().navigateUp()
            }

        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}